from numpy import *

u = loadtxt('u_bot.txt')
v = loadtxt('v_bot.txt')
w = loadtxt('w_bot.txt')
s = loadtxt('s_bot.txt')
x = loadtxt('xgrid.txt')

[Nx, Ny] = shape(u)

x_coord = x[:,0]
dx = x_coord[1:] - x_coord[0:-1]

dy = 2.5e3
b = 0
dt = 0.5

A = zeros((Nx*Ny, Nx*Ny))
R = zeros((Nx*Ny, 1))

s1 = zeros((Nx, Ny))


for i in arange(1, Nx):
    for j in arange(1, Ny-1):
        
        k = i*Ny + j

        A[k, k] = 1/dt + u[i,j]/dx[i-1]
        A[k, k-Ny] = -u[i,j]/dx[i-1]
        A[k, k+1] = v[i,j]/2/dy
        A[k, k-1] = v[i,j]/2/dy

        R[k, 0] = w[i,j] + b + s[i,j]/dt

for j in arange(0, Ny): 
    A[j, j] = 1
    R[j, 0] = s[0, j] + dt*(w[0,j] + b)

for i in arange(1, Nx):
    A[i*Ny+0, i*Ny+0] = 1/dt + u[i,0]/dx[i-1]
    A[i*Ny+0, i*Ny+0-Ny] = -u[i,0]/dx[i-1]
    R[i*Ny+0, 0] = w[i,0] + b + 1/dt*s[i,0]
    # j = 1

    A[i*Ny+Ny-1, i*Ny+Ny-1] = 1/dt + u[i,Ny-1]/dx[i-1]
    A[i*Ny+Ny-1, i*Ny+Ny-1-Ny] = -u[i,Ny-1]/dx[i-1]
    R[i*Ny+Ny-1, 0] = w[i,Ny-1] + b + 1/dt*s[i,Ny-1]
    # j = ny

s0 = linalg.solve(A, R)

for k in arange(0, Nx*Ny):
    if fix(k*1.0/Ny) == k*1.0/Ny:
        i = k*1.0/Ny
        i = int(i)
    else:
        i = fix(k*1.0/Ny)
        i = int(i)

    j = k - i*Ny
    s1[i,j] = s0[k]

ds = s1 - s;

savetxt('bot_dh_implicit_fdm.txt', ds, delimiter=' ');
 
print 'save bot dh \n'
