u = dlmread('u_sur.txt');
v = dlmread('v_sur.txt');
w = dlmread('w_sur.txt');
s = dlmread('s_sur.txt');
x = dlmread('x_sur.txt');


[Nx, Ny] = size(u);

x_coord = x(:,1);
dx = [x_coord(2:end) - x_coord(1:end-1)];

dy = 2.5e3;
b = 0; dt = 1;

A = zeros(Nx*Ny, Nx*Ny);
R = zeros(Nx*Ny, 1);


for i = 2:Nx
    for j = 2:Ny-1
        
        k = (i-1)*Ny + j;

        A(k, k) = 1/dt + u(i,j)/dx(i-1);
        A(k, k-Ny) = -u(i,j)/dx(i-1);
        A(k, k+1) = v(i,j)/2/dy;
        A(k, k-1) = v(i,j)/2/dy;

        R(k, 1) = w(i,j) + b + s(i,j)/dt;
    end
end

for j = 1:Ny
    A(j, j) = 1;
    R(j, 1) = s(1, j) + dt*(w(1,j) + b);
end

for i = 2:Nx
    A((i-1)*Ny+1, (i-1)*Ny+1) = 1/dt + u(i,1)/dx(i-1);
    A((i-1)*Ny+1, (i-1)*Ny+1-Ny) = -u(i,1)/dx(i-1);
    R((i-1)*Ny+1, 1) = w(i,1) + b + 1/dt*s(i,1);
    % j = 1

    A((i-1)*Ny+Ny, (i-1)*Ny+Ny) = 1/dt + u(i,Ny)/dx(i-1);
    A((i-1)*Ny+Ny, (i-1)*Ny+Ny-Ny) = -u(i,Ny)/dx(i-1);
    R((i-1)*Ny+Ny, 1) = w(i,Ny) + b + 1/dt*s(i,Ny);
    % j = Ny
end

s0 = A\R;

for k = 1:Nx*Ny
    if fix(k/Ny) == k/Ny
        i = k/Ny;
    else
        i = fix(k/Ny) + 1;
    end
    j = k - (i-1)*Ny;
    s1(i,j) = s0(k);
end

ds = s1 - s;

dlmwrite('sur_dH_implicit_fdm.txt', ds, ' ');
    






