#define MAT3_MM(A, B, C)			\
    C[0] += A[0]*B[0] + A[1]*B[3] + A[2]*B[6];	\
    C[1] += A[0]*B[1] + A[1]*B[4] + A[2]*B[7];	\
    C[2] += A[0]*B[2] + A[1]*B[5] + A[2]*B[8];	\
    C[3] += A[3]*B[0] + A[4]*B[3] + A[5]*B[6];	\
    C[4] += A[3]*B[1] + A[4]*B[4] + A[5]*B[7];	\
    C[5] += A[3]*B[2] + A[4]*B[5] + A[5]*B[8];	\
    C[6] += A[6]*B[0] + A[7]*B[3] + A[8]*B[6];	\
    C[7] += A[6]*B[1] + A[7]*B[4] + A[8]*B[7];	\
    C[8] += A[6]*B[2] + A[7]*B[5] + A[8]*B[8];

#define MAT3_MMt(A, B, C)			\
    C[0] += A[0]*B[0] + A[1]*B[1] + A[2]*B[2];	\
    C[1] += A[0]*B[3] + A[1]*B[4] + A[2]*B[5];	\
    C[2] += A[0]*B[6] + A[1]*B[7] + A[2]*B[8];	\
    C[3] += A[3]*B[0] + A[4]*B[1] + A[5]*B[2];	\
    C[4] += A[3]*B[3] + A[4]*B[4] + A[5]*B[5];	\
    C[5] += A[3]*B[6] + A[4]*B[7] + A[5]*B[8];	\
    C[6] += A[6]*B[0] + A[7]*B[1] + A[8]*B[2];	\
    C[7] += A[6]*B[3] + A[7]*B[4] + A[8]*B[5];	\
    C[8] += A[6]*B[6] + A[7]*B[7] + A[8]*B[8];

#define MAT3_DM(D, B, C)			\
    C[0] += D[0]*B[0];				\
    C[1] += D[0]*B[1];				\
    C[2] += D[0]*B[2];				\
    C[3] += D[1]*B[3];				\
    C[4] += D[1]*B[4];				\
    C[5] += D[1]*B[5];				\
    C[6] += D[2]*B[6];				\
    C[7] += D[2]*B[7];				\
    C[8] += D[2]*B[8];				

#define MAT3_MD(A, D, C)			\
    C[0] += A[0]*D[0];				\
    C[1] += A[1]*D[1];				\
    C[2] += A[2]*D[2];				\
    C[3] += A[3]*D[0];				\
    C[4] += A[4]*D[1];				\
    C[5] += A[5]*D[2];				\
    C[6] += A[6]*D[0];				\
    C[7] += A[7]*D[1];				\
    C[8] += A[8]*D[2];

#define MAT3_det(A)							\
    (A[0]*A[4]*A[8] - A[0]*A[5]*A[7] - A[1]*A[3]*A[8]			\
     + A[1]*A[5]*A[6] + A[2]*A[3]*A[7] - A[2]*A[4]*A[6])


#define MAT3_Mt(a) {				\
	FLOAT a_[9];				\
	memcpy(a_, a, 9 * sizeof(FLOAT));	\
	a[0] = a_[0];				\
	a[1] = a_[3];				\
	a[2] = a_[6];				\
	a[3] = a_[1];				\
	a[4] = a_[4];				\
	a[5] = a_[7];				\
	a[6] = a_[2];				\
	a[7] = a_[5];				\
	a[8] = a_[8];				\
    }

#define MAT3_AXPBY(a, x, b, y) {		\
	y[0] = (a) * x[0] + (b) * y[0];		\
	y[1] = (a) * x[1] + (b) * y[1];		\
	y[2] = (a) * x[2] + (b) * y[2];		\
	y[3] = (a) * x[3] + (b) * y[3];		\
	y[4] = (a) * x[4] + (b) * y[4];		\
	y[5] = (a) * x[5] + (b) * y[5];		\
	y[6] = (a) * x[6] + (b) * y[6];		\
	y[7] = (a) * x[7] + (b) * y[7];		\
	y[8] = (a) * x[8] + (b) * y[8];		\
    }

#define MAT3_NEG(a) {				\
	a[0] *= -1;				\
	a[1] *= -1;				\
	a[2] *= -1;				\
	a[3] *= -1;				\
	a[4] *= -1;				\
	a[5] *= -1;				\
	a[6] *= -1;				\
	a[7] *= -1;				\
	a[8] *= -1;				\
}

#define MAT3_ZERO(a) {				\
	bzero(a, 9 * sizeof(double));		\
}

#define MAT3_DUP(a, b) {			\
	b[0] = a[0];				\
	b[1] = a[1];				\
	b[2] = a[2];				\
	b[3] = a[3];				\
	b[4] = a[4];				\
	b[5] = a[5];				\
	b[6] = a[6];				\
	b[7] = a[7];				\
	b[8] = a[8];				\
}

#define MAT3_NORM2(a)				\
    sqrt(a[0]*a[0] + a[1]*a[1] + a[2]*a[2] +	\
	 a[3]*a[3] + a[4]*a[4] + a[5]*a[5] +	\
	 a[6]*a[6] + a[7]*a[7] + a[8]*a[8])

#define MAT3_NORM2_2(a)				\
    (a[0]*a[0] + a[1]*a[1] + a[2]*a[2] +	\
     a[3]*a[3] + a[4]*a[4] + a[5]*a[5] +	\
     a[6]*a[6] + a[7]*a[7] + a[8]*a[8])


#define MAT3_SYM(a, b)				\
    b[0] = a[0];				\
    b[4] = a[4];				\
    b[8] = a[8];				\
    b[1] = b[3] = .5 * (a[1] + a[3]);		\
    b[2] = b[6] = .5 * (a[2] + a[6]);		\
    b[5] = b[7] = .5 * (a[5] + a[7]);		
