format long

L = 800; % km
W = 50; % width

dy = 5; % 2.5 km 

dx0 = 5; % km

x_ge = 520; 
L_ge = 1e2;

x_ll = x_ge - L_ge/2;
x_rl = x_ge + L_ge/2;

x_ll = x_ge - 10;
x_rl = x_ge + 10;


q = 0.1;

x_l = zeros(1, 1000);
x_r = zeros(1, 1000);

for i = 1:length(x_l)
    x_l(1, i) = x_ll - dx0*(1-(1+q)^i)/(1-(1+q));
    x_r(1, i) = x_rl + dx0*(1-(1+q)^i)/(1-(1+q));
end

x_l(x_l < 0) = [];
x_r(x_r > L) = [];

if x_l(1, end) ~= 0
    x_l = [x_l, 0];
end

if x_r(1, end) ~= L
    x_r = [x_r, L];
end

x_ref = x_ll:dx0:x_rl;

x_l_flip = fliplr(x_l);

x_coord = [x_l_flip, x_ref, x_r];
%x_coord = dlmread('Elmer75D_x.txt');
%x_coord = x_coord(:,1); x_coord = x_coord'/1000;
%x_coord = x_coord'*1000;

nx = length(x_coord)
ny = W*10/dy/10 + 1

xgrid = zeros(nx, ny);
ygrid = zeros(nx, ny);

for i = 1:ny
    xgrid(:,i) = x_coord'*1000;
end

for i = 1:nx
    ygrid(i,:) = [0:dy:W]*1000;
end

dlmwrite('xgrid.txt', xgrid, 'delimiter', ' ', 'precision', 8);
dlmwrite('ygrid.txt', ygrid, 'delimiter', ' ', 'precision', 8);

points = zeros(nx*ny, 4);

for i = 1:nx
    for j = 1:ny
        points((i-1)*ny+j, 1) = (i-1)*ny+j;
        points((i-1)*ny+j, 2) = x_coord(i);
        points((i-1)*ny+j, 3) = -W*10/20*0+(j-1)*dy;
        points((i-1)*ny+j, 4) = 1;
    end
end

k = 3;
lines_out = zeros(2*(nx-1)+2*(ny-1), 4);
for i=1:nx-1
    lines_out(i, 1) = i;
    lines_out(i, 2) = points((i-1)*ny+1, 1);
    lines_out(i, 3) = points(i*ny+1, 1);
    lines_out(i, 4) = k;
    k = k+1;
end

for j=1:ny-1
    lines_out(j+nx-1, 1) = j+nx-1;
    lines_out(j+nx-1, 2) = points((nx-1)*ny+j, 1);
    lines_out(j+nx-1, 3) = points((nx-1)*ny+j+1, 1);
    lines_out(j+nx-1, 4) = k;
    k = k+1;
end
for i=nx:-1:2
    lines_out(nx+1-i+nx+ny-2, 1) = nx+1-i+nx+ny-2;
    lines_out(nx+1-i+nx+ny-2, 2) = points((i-1)*ny+ny, 1);
    lines_out(nx+1-i+nx+ny-2, 3) = points((i-2)*ny+ny, 1);
    lines_out(nx+1-i+nx+ny-2, 4) = k;
    k = k+1;
end
for j=ny:-1:2
    lines_out(ny+1-j+2*nx+ny-3, 1) = ny+1-j+2*nx+ny-3;
    lines_out(ny+1-j+2*nx+ny-3, 2) = points(j, 1);
    lines_out(ny+1-j+2*nx+ny-3, 3) = points(j-1, 1);
    lines_out(ny+1-j+2*nx+ny-3, 4) = k;
    k = k+1;
end

lines_in = zeros(nx*(ny-1)+ny*(nx-1)-2*(nx-1)-2*(ny-1),4);

for i=2:nx-1
    for j=1:ny-1
        lines_in((i-2)*(ny-1)+j, 1) = 2*(nx-1)+2*(ny-1)+(i-2)*(ny-1)+j;
        lines_in((i-2)*(ny-1)+j, 2) = points((i-1)*ny+j, 1);
        lines_in((i-2)*(ny-1)+j, 3) = points((i-1)*ny+j+1, 1);
        lines_in((i-2)*(ny-1)+j, 4) = k;
        k = k+1;
    end
end

for j=2:ny-1
    for i=1:nx-1
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 1) = 2*(nx-1)+2*(ny-1) + (j-2)*(nx-1)+i+(nx-2)*(ny-1);
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 2) = points((i-1)*ny+j, 1);
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 3) = points((i-1)*ny+j+ny, 1);
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 4) = k;
        k = k+1;
    end
end

np = length(points(:,1));
nl = length(lines_out(:,1)) + length(lines_in(:,1));
p_header = [np, 2, 0, 1];
l_header = [nl, 1, NaN, NaN];
h_header = [0, NaN, NaN, NaN];

p_and_l = [p_header;points;l_header;lines_out;lines_in;h_header];

dlmwrite('mesh.poly', p_and_l, '\t');
dlmwrite('xgrid.txt',xgrid,' ');
dlmwrite('ygrid.txt',ygrid,' ');
