L = 800; % total length of the domain [ km ]
W = 50; % width of the domain [ km ]

dx = 0.1; % dx in the densified region [ km ]
dy = 0.1; % dy in the densified region [ km ]

x_ge = 536.1;  % initial GL position 
x_ll = x_ge - 10;
x_rl = x_ge + 10;

L_den = x_rl - x_ll; % length of the region that we want to densify [ km ]
x_den = x_ll; % start x position of this region [ km ]




ll_x = 0;
ll_y = 0;

rl_x = L;
rl_y = 0;

ru_x = L;
ru_y = W;

lu_x = 0;
lu_y = W;


nx = L_den/dx+1;
ny = W/dy+1;

x = 0:dx:L;
%y = W/20:-dy:-W/20;
y = W/10:-dy:0;

points = zeros(nx*ny+4, 4);

for i=1:nx
    for j=1:ny
        points((i-1)*ny+j, 1) = (i-1)*ny+j;
        points((i-1)*ny+j, 2) = (i-1)*dx + x_den;
        points((i-1)*ny+j, 3) = (j-1)*dy; %-W/20+(j-1)*dy;
        points((i-1)*ny+j, 4) = 1;
    end
end

points(end-3, 1) = nx*ny + 1;
points(end-3, 2) = ll_x;
points(end-3, 3) = ll_y;
points(end-3, 4) = 1;

points(end-2, 1) = nx*ny + 2;
points(end-2, 2) = rl_x;
points(end-2, 3) = rl_y;
points(end-2, 4) = 1;

points(end-1, 1) = nx*ny + 3;
points(end-1, 2) = ru_x;
points(end-1, 3) = ru_y;
points(end-1, 4) = 1;

points(end, 1) = nx*ny + 4;
points(end, 2) = lu_x;
points(end, 3) = lu_y;
points(end, 4) = 1;

k = 3;

lines_out = zeros(2*(nx-1)+6, 4);
lines_out(1, 1) = 1;
lines_out(1, 2) = points(end-3, 1);
lines_out(1, 3) = points(1, 1);
lines_out(1, 4) = k;

k = k+1;

for i=1:nx-1
    lines_out(i+1, 1) = i + 1;
    lines_out(i+1, 2) = points((i-1)*ny+1, 1);
    lines_out(i+1, 3) = points(i*ny+1, 1);
    lines_out(i+1, 4) = k;
    k = k+1;
end

lines_out(nx+1, 1) = nx+1;
lines_out(nx+1, 2) = points((nx-1)*ny+1, 1);
lines_out(nx+1, 3) = points(end-2, 1);
lines_out(nx+1, 4) = k;

k = k+1;

lines_out(nx+2, 1) = nx+2;
lines_out(nx+2, 2) = points(end-2, 1);
lines_out(nx+2, 3) = points(end-1, 1);
lines_out(nx+2, 4) = k;

k = k+1;

lines_out(nx+3, 1) = nx+3;
lines_out(nx+3, 2) = points(end-1, 1);
lines_out(nx+3, 3) = points(nx*ny, 1);
lines_out(nx+3, 4) = k;

k = k+1;

for i=nx:-1:2
    lines_out(nx+4-i+nx, 1) = nx+4-i+nx;
    lines_out(nx+4-i+nx, 2) = points((i-1)*ny+ny, 1);
    lines_out(nx+4-i+nx, 3) = points((i-2)*ny+ny, 1);
    lines_out(nx+4-i+nx, 4) = k;
    k = k+1;
end


lines_out(2*nx+3, 1) = 2*nx+3;
lines_out(2*nx+3, 2) = points(ny, 1);
lines_out(2*nx+3, 3) = points(end, 1);
lines_out(2*nx+3, 4) = k;

k = k+1;


lines_out(2*nx+4, 1) = 2*nx+4;
lines_out(2*nx+4, 2) = points(end, 1);
lines_out(2*nx+4, 3) = points(end-3, 1);
lines_out(2*nx+4, 4) = k;

k = k+1;


%for j=1:ny-1
%    lines_out(j+2*nx+4, 1) = j+2*nx+4;
%    %lines_out(ny-j+ny+2*nx+4, 1) = ny-j+ny+2*nx+4;
%    lines_out(j+2*nx+4, 2) = points(j, 1);
%    lines_out(j+2*nx+4, 3) = points(j+1, 1);
%    lines_out(j+2*nx+4, 4) = k;
%    k = k+1;
%end

%for j=1:ny-1
%    lines_out(ny-j+ny+2*nx+4, 1) = j+2*nx+4;
%    lines_out(ny-j+ny+2*nx+4, 2) = points((nx-1)*ny+j, 1);
%    lines_out(ny-j+ny+2*nx+4, 3) = points((nx-1)*ny+j+1, 1);
%    lines_out(ny-j+ny+2*nx+4, 4) = k;
%    k = k+1;
%end

%lines_in = zeros(nx*(ny-1)+ny*(nx-1)-2*(nx-1)-2*(ny-1),4);
lines_in = zeros(nx*(ny-1)+(ny-2)*(nx-1),4);

for i=1:nx
    for j=1:ny-1
        lines_in((i-1)*(ny-1)+j, 1) = 2*nx + 4 + (i-1)*(ny-1)+j; %2*(nx-1)+2*(ny-1)+(i-2)*(ny-1)+j;
        lines_in((i-1)*(ny-1)+j, 2) = points((i-1)*ny+j, 1);
        lines_in((i-1)*(ny-1)+j, 3) = points((i-1)*ny+j+1, 1);
        lines_in((i-1)*(ny-1)+j, 4) = k;
        k = k+1;
    end
end

for j=2:ny-1
    for i=1:nx-1
        lines_in((j-2)*(nx-1)+(nx-1)*(ny-1)+ny+i-1, 1) = (j-2)*(nx-1)+i+2*nx+4+nx*(ny-1);
        lines_in((j-2)*(nx-1)+(nx-1)*(ny-1)+ny+i-1, 2) = points((i-1)*ny+j, 1);
        lines_in((j-2)*(nx-1)+(nx-1)*(ny-1)+ny+i-1, 3) = points((i-1)*ny+j+ny, 1);
        lines_in((j-2)*(nx-1)+(nx-1)*(ny-1)+ny+i-1, 4) = k;
        k = k+1;
    end
end

np = length(points(:,1));
nl = length(lines_out(:,1)) + length(lines_in(:,1));
p_header = [np, 2, 0, 1];
l_header = [nl, 1, NaN, NaN];
h_header = [0, NaN, NaN, NaN];
p_and_l = [p_header;points;l_header;lines_out;lines_in;h_header];

dlmwrite('mesh.poly', p_and_l, '\t');
