L = 1500; % km
W = 1500; 
dx = 50;
dy = 50;

nx = L/dx+1
ny = W/dy+1

x = 0:dx:L;
%y = W/20:-dy:-W/20;
%y = W/10:-dy:0;
y = 0:dy:W;

[coord_x, coord_y] = meshgrid(x,y);

points = zeros(nx*ny, 4);

for i=1:nx
    for j=1:ny
        points((i-1)*ny+j, 1) = (i-1)*ny+j;
        points((i-1)*ny+j, 2) = (i-1)*dx;
        points((i-1)*ny+j, 3) = (j-1)*dy; %-W/20+(j-1)*dy;
        points((i-1)*ny+j, 4) = 1;
    end
end

k = 3;
lines_out = zeros(2*(nx-1)+2*(ny-1), 4);
for i=1:nx-1
    lines_out(i, 1) = i;
    lines_out(i, 2) = points((i-1)*ny+1, 1);
    lines_out(i, 3) = points(i*ny+1, 1);
    lines_out(i, 4) = k;
    k = k+1;
end
for j=1:ny-1
    lines_out(j+nx-1, 1) = j+nx-1;
    lines_out(j+nx-1, 2) = points((nx-1)*ny+j, 1);
    lines_out(j+nx-1, 3) = points((nx-1)*ny+j+1, 1);
    lines_out(j+nx-1, 4) = k;
    k = k+1;
end
for i=nx:-1:2
    lines_out(nx+1-i+nx+ny-2, 1) = nx+1-i+nx+ny-2;
    lines_out(nx+1-i+nx+ny-2, 2) = points((i-1)*ny+ny, 1);
    lines_out(nx+1-i+nx+ny-2, 3) = points((i-2)*ny+ny, 1);
    lines_out(nx+1-i+nx+ny-2, 4) = k;
    k = k+1;
end
for j=ny:-1:2
    lines_out(ny+1-j+2*nx+ny-3, 1) = ny+1-j+2*nx+ny-3;
    lines_out(ny+1-j+2*nx+ny-3, 2) = points(j, 1);
    lines_out(ny+1-j+2*nx+ny-3, 3) = points(j-1, 1);
    lines_out(ny+1-j+2*nx+ny-3, 4) = k;
    k = k+1;
end

lines_in = zeros(nx*(ny-1)+ny*(nx-1)-2*(nx-1)-2*(ny-1),4);

for i=2:nx-1
    for j=1:ny-1
        lines_in((i-2)*(ny-1)+j, 1) = 2*(nx-1)+2*(ny-1)+(i-2)*(ny-1)+j;
        lines_in((i-2)*(ny-1)+j, 2) = points((i-1)*ny+j, 1);
        lines_in((i-2)*(ny-1)+j, 3) = points((i-1)*ny+j+1, 1);
        lines_in((i-2)*(ny-1)+j, 4) = k;
        k = k+1;
    end
end

for j=2:ny-1
    for i=1:nx-1
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 1) = 2*(nx-1)+2*(ny-1) + (j-2)*(nx-1)+i+(nx-2)*(ny-1);
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 2) = points((i-1)*ny+j, 1);
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 3) = points((i-1)*ny+j+ny, 1);
        lines_in((j-2)*(nx-1)+i+(nx-2)*(ny-1), 4) = k;
        k = k+1;
    end
end

np = length(points(:,1));
nl = length(lines_out(:,1)) + length(lines_in(:,1));
p_header = [np, 2, 0, 1];
l_header = [nl, 1, NaN, NaN];
h_header = [0, NaN, NaN, NaN];
p_and_l = [p_header;points;l_header;lines_out;lines_in;h_header];
%p_and_l = [points;lines_out;lines_in];

dlmwrite('mesh.poly', p_and_l, '\t');
dlmwrite('simple_geo.txt', p_and_l, '\t');
